<!doctype html>
<html class="not-ready lg:text-base" lang="en">
  <head>
  <meta charset="utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />

  <!-- Title -->
  <title>
    mini-project3 - Home
  </title>

  <!-- Meta -->
  <meta name="theme-color" />

  <!-- Author -->
  
  <meta name="description" content="mini-project3" />
  <meta name="author" content="mini-project3" />
  

  <!-- CSS & JS -->
  <link rel="preload stylesheet" as="style" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/main.css" />
  <style>
    :root {
      --bg: #f4f4f5;
      --bg-dark: #18181b;
      --header: #e4e4e7;
      --header-dark: #27272a;
    }
  </style>

  

  <!-- Dark Icon -->
  <link rel="preload" as="image" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/icons/theme.svg" />

  <!-- Math -->
  
  <!---->

  <!-- Mermaid -->
  
  <!---->

  <!-- Favicon -->
  <link rel="icon" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/favicon.ico" />
  <link rel="apple-touch-icon" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/apple-touch-icon.png" />

  <!-- Feeds -->
  
  <!---->
  
  <link
    rel="alternate"
    type="application/atom+xml"
    title="Atom"
    href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/atom.xml"
  />
  
  <!---->
  

  <!-- Canonical -->
  <link rel="canonical" href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project3&#x2F;" />
</head>

  <body class="text-black duration-200 ease-out dark:text-white">
    <header
  class="header fixed top-0 z-40 mx-auto min-h-[3.5rem] w-full"
>
  <div class="mx-auto w-full max-w-4xl p-3 lg:flex lg:justify-between">
    <div class="flex justify-between">
      <div class="flex items-center">
        <a class="text-2xl font-semibold" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io">Home</a>
        <div
          class="btn-dark ml-4 h-6 w-6 shrink-0 cursor-pointer text-[0] [background:url(./icons/theme.svg)_left_center/cover_no-repeat] dark:invert dark:[background-position:right]"
          role="button"
          aria-label="Dark"
        ></div>
      </div>
      
      <div
        class="btn-menu relative z-50 flex h-8 w-8 shrink-0 cursor-pointer flex-col items-center justify-center gap-2.5 lg:hidden"
        role="button"
        aria-label="Menu"
      ></div>
      
    </div>
    <script>
      // base
      const htmlClass = document.documentElement.classList;
      setTimeout(() => {
        htmlClass.remove("not-ready");
      }, 10);

      // mobile menu
      const btnMenu = document.querySelector(".btn-menu");
      btnMenu?.addEventListener("click", () => {
        htmlClass.toggle("open");
      });

      // dark theme
      const setDark = (isDark) => {
        htmlClass[isDark ? "add" : "remove"]("dark");
        localStorage.setItem("dark", isDark);
      };

      // init
      const darkScheme = window.matchMedia("(prefers-color-scheme: dark)");
      if (htmlClass.contains("dark")) {
        setDark(true);
      } else {
        const darkVal = localStorage.getItem("dark");
        setDark(darkVal ? darkVal === "true" : darkScheme.matches);
      }

      // listen system
      darkScheme.addEventListener("change", (event) => {
        setDark(event.matches);
      });

      // manual switch
      const btnDark = document.querySelector(".btn-dark");
      btnDark.addEventListener("click", () => {
        setDark(localStorage.getItem("dark") !== "true");
      });
    </script>
    
    <nav class="flex w-full items-center lg:w-auto">
      <ul
        class="nav-wrapper flex w-full flex-col py-2 lg:w-auto lg:flex-row lg:self-center lg:py-0"
      >
        
        <li>
          <a
            class="primary-link block py-2 text-center text-lg font-medium lg:px-3 lg:py-0"
            href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects"
            >Projects</a
          >
        </li>
        
        <li>
          <a
            class="primary-link block py-2 text-center text-lg font-medium lg:px-3 lg:py-0"
            href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/About"
            >About</a
          >
        </li>
        
      </ul>
    </nav>
    
  </div>
</header>


    <main
      class="prose prose-neutral relative mx-auto min-h-[calc(100%-9rem)] max-w-3xl px-4 pb-16 pt-32 dark:prose-invert"
    >
      
<article>
  <header class="mb-16">
    <h1 class="!my-0 pb-2.5">mini-project3</h1>
    <div class="text-sm antialiased opacity-60">
  
  <time>2024-02-13</time>
  <span class="mx-1">&middot;</span>
  <span>1min</span>
  <!---->
  
  <!---->
  
  <span class="mx-1">&middot;</span>
  <span>yanbo</span>
  
</div>

  </header>

  

  <!-- TOC -->
  <!---->
<div class="block-bg mb-12 flex rounded-lg p-2 text-lg">
  <details>
    <summary class="cursor-pointer py-1 pl-4">
      <span>Table of Contents</span>
    </summary>
    <div class="px-2">
      <ul>
        
        <li>
          <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project3/#yg229-mini-project-3"
            >yg229_mini_project_3</a
          >
          
          <ul>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project3/#author"
                >Author</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project3/#configuration-and-initialization"
                >Configuration and Initialization:</a
              >
            </li>
            
          </ul>
          
        </li>
        
      </ul>
    </div>
  </details>
</div>

<!---->

  <!-- Content -->
  <section><ul>
<li>Link to mini-project 3: <a href="https://gitlab.com/dukeaiml/IDS721/mini-project3-yg229.git">GitLab repo</a></li>
</ul>
<h1 id="yg229-mini-project-3">yg229_mini_project_3</h1>
<p>In this project, I create an S3 Bucket named 'mini3-bucket' using CDK with AWS CodeWhisperer.</p>
<h2 id="author">Author</h2>
<p>Yanbo Guan</p>
<h2 id="configuration-and-initialization">Configuration and Initialization:</h2>
<ol>
<li>
<p>Download AWS Toolkit
<img src="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project3/1.png" alt="" /></p>
</li>
<li>
<p>Download node.js</p>
</li>
<li>
<p>Install AWS CDK: <code> npm install -g aws-cdk</code></p>
</li>
<li>
<p>Install the S3 Package: <code> npm install @aws-cdk/aws-s3</code></p>
</li>
<li>
<p>Initialize a new CDK project with <code>cdk init app --language=typescript</code></p>
</li>
<li>
<p>Use Code Whispper to Generate S3 Bucket Code: In the file <code>mini3-bucket-stack.ts</code>, write the comment as below</p>
</li>
</ol>
<pre style="background-color:#2b303b;color:#c0c5ce;"><code><span>// Use AWS CDK to create an S3 bucket with versioning and encryption enabled.
</span></code></pre>
<ol start="7">
<li>Press Enter at the end of the comment, tap to confirm the code.</li>
<li>Prepare an AWS environment for CDK deployments <code>cdk bootstrap aws://533267227404/us-east-1 </code>
<img src="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project3/2.png" alt="" /></li>
<li>Deploy the project. <code>cdk deploy</code>
<img src="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project3/3.png" alt="" />
The new bucket created by CDK is shown on S3 Bucket webpage</li>
</ol>
</section>

  <hr />

  <!-- Post Taxonomies -->
  
<!---->

  <!-- Post Nav -->
  
<nav class="block-bg mt-12 flex rounded-lg text-lg">
  
  <a
    class="block-hover-mask flex w-1/2 items-center rounded-l-md p-6 pr-3 font-semibold no-underline"
    href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project2&#x2F;"
    ><span class="mr-1.5">←</span><span>mini-project2</span></a
  >
  <!---->
  
  <a
    class="block-hover-mask ml-auto flex w-1/2 items-center justify-end rounded-r-md p-6 pl-3 font-semibold no-underline"
    href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project4&#x2F;"
    ><span>mini-project4</span><span class="ml-1.5">→</span></a
  >
  
</nav>

<!---->

  <!-- Comment -->
  
</article>

    </main>

    <footer class="mx-auto flex max-w-3xl flex-wrap items-center px-8 py-4 text-sm opacity-60">
  <div class="mr-auto basis-full lg:basis-1/2">
    &copy; 2020 -  2024
    <a class="link" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io"
      >yanbo</a
    >
     |<!---->
    <!---->
    <a class="link" href="https:&#x2F;&#x2F;creativecommons.org&#x2F;licenses&#x2F;by-sa&#x2F;4.0&#x2F;deed" rel="noopener" target="_blank">
      CC BY-SA 4.0
    </a>
    <!---->
    
  </div>
  <div class="flex basis-full lg:basis-1/2 lg:justify-end">
    <a class="link mr-6 lg:ml-6" href="https://www.getzola.org/" rel="noopener" target="_blank"
      >Powered by Zola</a
    >
    <a class="link" href="https://github.com/st1020/kita" rel="noopener" target="_blank">✎ Kita</a>
  </div>
</footer>

  </body>
</html>
